/**
* @brief
websocketͻ˹

* @version
  V 1.0.0

* @author
  濡

* @date
  ʱ:  2018-08-17\n

* @note
  2018-08-17  ࡣ\n

* @warning

* @bug
  
*/

#pragma once

#include <vector>
#include <string>
#include <map>

#include "wsClient.h"
#include <boost/serialization/singleton.hpp>

namespace YA
{
	class wsClientMgr
	{
	private:
		std::vector<std::shared_ptr<wsClient>> __wsClientList;//wsͻб
		std::map<std::string,int>  __uriIndexList;//uriͿͻ±Ӧ
		std::string __LastError;//´
		std::recursive_mutex __lock;//
	public:
		wsClientMgr();
		~wsClientMgr();
		/**
		* @brief
		  []

		* @param  [in] int index  ±\n

		* @return ±ӦĿͻ\n

		* @note

		* @warning

		* @bug

		*/
		std::shared_ptr<wsClient> operator[]( int index )
		{
			std::lock_guard<std::recursive_mutex> lock( __lock );
			std::shared_ptr<wsClient> pClient;

			if ( index < 0 )
			{
				return pClient;
			}

			if ( index <(int) __wsClientList.size() )
			{
				pClient = __wsClientList[index];
			}

			return pClient;
		}
		/**
		* @brief
		캯

		* @param  [in] const std::vector<std::string> uri_list  uriб\n
		* @param  [in] const std::map<std::string, MSG_HANDLE_FUNC_TYPE>& MsgFuncList  б\n

		* @return ӷǷɹ\n
		* @retval  0  ɹ\n
        * @retval  -1  ʧ\n

		* @note

		* @warning

		* @bug

		*/
		void Build( const std::vector<std::string> uri_list, const std::map<std::string, MSG_HANDLE_FUNC_TYPE>& MsgFuncList );
		/**
		* @brief
		Ӻ

		* @param  [in] int time_out  ʱ(λ),Ĭ3\n

		* @return ӷǷɹ\n
		* @retval  0  ɹ\n
        * @retval  -1  ʧ\n

		* @note

		* @warning

		* @bug

		*/
		int connect( int time_out = 3 );
		/**
		* @brief
		¼

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void login();
		/**
		* @brief
		ݺ

		* @param  [in] const std::string & Cmd  Ҫ͵\n
		* @param  [in] const std::string& Data  Ҫ͵\n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void send( const std::string & Cmd, const std::string & Data );
		/**
		* @brief
		URI(Ӵ)öӦĿͻ˺

		* @param  [in] const std::string& URI  \n

		* @return õĿͻ\n

		* @note

		* @warning

		* @bug

		*/
		std::shared_ptr<wsClient> GetClientByURI( const std::string& URI );
		/**
		* @brief
		رպ

		* @param  \n

		* @return \n

		* @note

		* @warning

		* @bug

		*/
		void close();
		/**
		* @brief
		Ƿӷ˺

		* @param  \n

		* @return Ƿӷ\n

		* @note

		* @warning

		* @bug

		*/
		bool IsConnected();
		/**
		* @brief
		Ƿѵ¼ɹ

		* @param  \n

		* @return Ƿѵ¼ɹ\n

		* @note

		* @warning

		* @bug

		*/
		bool IsLogined();
		/**
		* @brief
		SocketǷѴ򿪺

		* @param  \n

		* @return SocketǷѴ\n

		* @note

		* @warning

		* @bug

		*/
		bool IsSktOpened();
	};
}

//ض
typedef boost::serialization::singleton<YA::wsClientMgr> singleton_wsClientMgr;
#define swsClientMgr singleton_wsClientMgr::get_mutable_instance()
#define swsClientMgr_const singleton_wsClientMgr::get_const_instance()
